# WEB+DB PRESS Vol.104 連載「実践！ 先進的インフラ運用」サンプルコード

技術評論社刊「WEB+DB PRESS Vol.104」の連載「実践！ 先進的インフラ運用」第6回「HashiCorp Vaultで秘密情報の一括管理」（小田 知央著）のサンプルコードです。

## docker-composeによる各コンテナの起動

このサンプルコードは、本誌で解説した手順が既に設定されている状態です。`docker-compose up` コマンドを実行すると、以下のコンテナが起動します。起動後のVaultとそのほかの連携は、本誌の通りです。

- consul
- vault 1
- vault 2
- sshd（本誌に解説なし）
- mysql
- rails

## VaultからSSHログイン権限の発行

本誌に解説はありませんが「VaultからSSHログイン権限の発行」を以下の手順で行えます。

### SSHシークレットエンジンの設定

VaultのSSHシークレットエンジンを有効化し、事前に作成済みのユーザをdefault_userとし、接続するネットワークを指定してワンタイムパスワードを発行する設定にします。

```sh
$ vault secrets enable ssh
$ vault write ssh/roles/operator \
  key_type=otp default_user=ops \
  cidr_list=127.0.0.0/8,172.0.0.0/8,192.0.0.0/8
```

### ワンタイムトークンをVaultから発行してSSHログイン

先ほど設定したパスのrolesをcredsに変更したパスで接続サーバIPを指定しSSHログインパスワードを発行します。そして、発行されたkeyをログイン時に入力することで認証が成功します。

```sh
$ vault write ssh/creds/operator ip=127.0.0.1
Key                Value
---                -----
（省略）
ip                 127.0.0.1
key                8f7cb...（省略）
username           ops

$ ssh ops@localhost -p 10022
ops@ubuntu:~$
```